Package x2go :: Module mimebox :: Class X2GoMIMEboxQueue

[frames] | no frames]

# Class X2GoMIMEboxQueue

source code

            object --+
                     |
    threading._Verbose --+
                         |
          threading.Thread --+
                             |
                            X2GoMIMEboxQueue

If the X2Go MIME box is supported in a particaluar X2GoSession instance this class provides a sub-thread for handling incoming files in the MIME box directory. The actual handling of a dropped file is handled by the classes X2GoMIMEboxActionOPEN, X2GoMIMEboxActionOPENWITH and X2GoMIMEboxActionSAVEAS.

Instance Methods

__init__(self, profile_name=`'``UNKNOWN``'`, session_name=`'``UNKNOWN``'`, mimebox_dir=None, mimebox_action=None, mimebox_extensions=`[``]`, client_instance=None, logger=None, loglevel=56) This constructor should always be called with keyword arguments. | source code

__del__(self) Class destructor. | source code

pause(self) Prevent acceptance of new incoming files. | source code

resume(self) Resume operation of the X2Go MIME box queue and continue accepting new incoming files. | source code

stop_thread(self) Stops this X2GoMIMEboxQueue thread completely. | source code

set_mimebox_action(self, mimebox_action, **kwargs) Modify the MIME box action of this X2GoMIMEboxQueue thread during runtime. | source code

run(self) This method gets called once the X2GoMIMEboxQueue thread is started by the `X2GoMIMEboxQueue.start()` method. | source code

Inherited from `threading.Thread`: `__repr__`, `getName`, `isAlive`, `isDaemon`, `is_alive`, `join`, `setDaemon`, `setName`, `start` Inherited from `object`: `__delattr__`, `__format__`, `__getattribute__`, `__hash__`, `__new__`, `__reduce__`, `__reduce_ex__`, `__setattr__`, `__sizeof__`, `__str__`, `__subclasshook__`

Class Variables
| mimebox_action = `None`
| mimebox = `None`
| active_jobs = ``{``}``
| mimebox_history = ``[``]``

Properties
Inherited from `threading.Thread`: `daemon`, `ident`, `name` Inherited from `object`: `__class__`

Method Details

### __init__(self, profile_name=`'``UNKNOWN``'`, session_name=`'``UNKNOWN``'`, mimebox_dir=None, mimebox_action=None, mimebox_extensions=`[``]`, client_instance=None, logger=None, loglevel=56)
(Constructor)

source code

This constructor should always be called with keyword arguments. Arguments are:

*group* should be None; reserved for future extension when a ThreadGroup class is implemented.

*target* is the callable object to be invoked by the run() method. Defaults to None, meaning nothing is called.

*name* is the thread name. By default, a unique name is constructed of the form "Thread-N" where N is a small decimal number.

*args* is the argument tuple for the target invocation. Defaults to ().

*kwargs* is a dictionary of keyword arguments for the target invocation. Defaults to {}.

If a subclass overrides the constructor, it must make sure to invoke the base class constructor (Thread.__init__()) before doing anything else to the thread.

Parameters:
  - `profile_name` (`str`) - name of the session profile this print queue belongs to
  - `mimebox_dir` (`str`) - local directory for incoming MIME box files
  - `mimebox_action` (`str` or instance) - name or instance of either of the possible X2Go print action classes
  - `client_instance` (`obj`) - the underlying X2GoClient instance
  - `logger` (`obj`) - you can pass an X2GoLogger object to the X2GoPrintQueue constructor
  - `loglevel` (`int`) - if no X2GoLogger object has been supplied a new one will be constructed with the given loglevel
Overrides: object.__init__

### pause(self)

source code

Prevent acceptance of new incoming files. The processing of MIME box jobs that are currently still active will be completed, though.

### set_mimebox_action(self, mimebox_action, **kwargs)

source code

Modify the MIME box action of this X2GoMIMEboxQueue thread during runtime. The change of the MIME box action will be valid for the next incoming file in the MIME box directory.

Parameters:
  - `mimebox_action` (`str` or `obj`) - the MIME box action to execute for incoming files
  - `kwargs` (`dict`) - extra options for the specified MIME box action

### run(self)

source code

This method gets called once the X2GoMIMEboxQueue thread is started by the `X2GoMIMEboxQueue.start()` method.

Overrides: threading.Thread.run